//---------------------------------------------------------------------------
// I/O Interfacer for Windows 95/98 
// io.cpp (function definitions)
// v5.4
//

//Note: NOT TO BE COMPILED OR RUN UNDER OTHER OPERATING PLATFORMS,
//INCLUDING Microsoft Windows NT/NT4/2000 Pro/Server/Advanced Server.


// Copyright 2001 by Daniel Kho Cheok Kiang.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted in any form or by any
// means, be it electrical, mechanical, photocopying, recording, or
// otherwise, without the prior written permission of the author.
//

/** Note:
Special exclusive rights have been granted to Inprise Corporation, and
its staff to edit or modify, correct, improve, rectify or troubleshoot
any bugs/errors, redistribute and package this code under the name of
Inprise, provided that the author's name is at least credited or
included as a Portions Copyright.

/****************************************************************************
DISCLAIMER
To the maximum extent permitted by applicable law, in no event shall the
author be liable for any special, incidental, indirect, or consequential
damages whatsoever (including, but not limited to damages for loss of
business profits, business interruption, loss of business information,
or any other pecuniary loss) arising out of the use of or inability to
use or misuse of the software product or the provision of or failure to
provide support services, even if the author has been advised of the
possibility of such damages.
/***************************************************************************/

#include <vcl.h>
#include"io.h"
#pragma hdrstop
//---------------------------------------------------------------------------
USERES("io.res");
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
        return 1;
}
//---------------------------------------------------------------------------

void outport(__int16 addr,__int32 data)
{
  asm
  {
    mov dx,addr
    mov eax,data
    out dx,eax          //doubleword data in eax is sent to port dx
  }
}

void outportw(__int16 addr,__int16 data)
{
  asm
  {
    mov dx,addr
    mov ax,data
    out dx,ax
  }
}

void outportb(__int16 addr,__int8 data)
{
  asm
  {
    mov dx,addr
    mov al,data
    out dx,al
  }
}

long inport(__int16 addr)
{
  __int32 data=0;
  asm
  {
    mov dx,addr
    in  eax,dx          //word data at port dx is saved in eax
    mov data,eax
  }
  return data;
}

int inportw(__int16 addr)
{
  __int16 data=0;
  asm
  {
    mov dx,addr
    in  ax,dx
    mov data,ax
  }
  return data;
}

short inportb(__int16 addr)
{
  __int8 data=0;
  asm
  {
    mov dx,addr
    in  al,dx
    mov data,al
  }
  return data;
}

void outpw(__int16 addr,__int8 data)
{
  outportw(addr,data);
  Error1();
}

void outpb(__int16 addr,__int8 data)
{
  outportb(addr,data);
  Error1();
}

int inpw(__int16 addr)
{
  inportw(addr);
  Error1();
  return 0;
}

short inpb(__int16 addr)
{
  inportb(addr);
  Error1();
  return 0;
}

void Message()
{
  MessageBox(NULL,"DLL successfully called.","Operation Success!",MB_OK);
}

void Error1()
{
  MessageBox(NULL,"This function is unavailable in this release.","Function unavailable!",MB_OK);
}
