//---------------------------------------------------------------------------
// I/O Interfacer
// Header file [io.h]
// v5.4
//
// Copyright 2001 by Daniel Kho Cheok Kiang.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted in any form or by any
// means, be it electrical, mechanical, photocopying, recording, or
// otherwise, without the prior written permission of the author.
//

/****************************************************************************
DISCLAIMER
To the maximum extent permitted by applicable law, in no event shall the
author be liable for any special, incidental, indirect, or consequential
damages whatsoever (including, but not limited to damages for loss of
business profits, business interruption, loss of business information,
or any other pecuniary loss) arising out of the use of or inability to
use or misuse of the software product or the provision of or failure to
provide support services, even if the author has been advised of the
possibility of such damages.
/***************************************************************************/

#ifndef io_H
#define io_H

#ifdef _buildIOdll
#define _TYPE __export
#else
#define _TYPE __import
#endif


class io//__declspec(dllexport) io
{
public:
  //long addr,val;

protected:
private:
  void friend _TYPE outport(__int16,__int32);
  void friend _TYPE outportw(__int16,__int16);
  void friend _TYPE outportb(__int16,__int8);
  void friend _TYPE outpw(__int16,__int16);
  void friend _TYPE outpb(__int16,__int8);

  long friend _TYPE inport(__int16);
  int friend _TYPE inportw(__int16);
  short friend _TYPE inportb(__int16);
  int friend _TYPE inpw(__int16);
  short friend _TYPE inpb(__int16);

  void friend _TYPE Message();
  void friend _TYPE Error1();
};

extern PACKAGE io *call;
#endif
