//---------------------------------------------------------------------------
// I/O Interfacer for Microsoft Windows 95/98.
// testIO.cpp (sample app for io.dll implementation)
// v5.4
//

//Note: NOT TO BE COMPILED OR RUN UNDER OTHER OPERATING PLATFORMS,
//INCLUDING Microsoft Windows NT/NT4 or MS Windows 2000 Professional/Server/Advanced Server.

//
// Copyright 2001 by Daniel Kho Cheok Kiang.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted in any form or by any
// means, be it electrical, mechanical, photocopying, recording, or
// otherwise, without the prior written permission of the author.
//                                                                    

/** Note:
Special exclusive rights have been granted to Inprise Corporation, and
its staff to edit or modify, correct, improve, rectify or troubleshoot
any bugs/errors, redistribute and package this code under the name of
Inprise, provided that the author's name is at least credited or
included as a Portions Copyright.

/****************************************************************************
DISCLAIMER
To the maximum extent permitted by applicable law, in no event shall the
author be liable for any special, incidental, indirect, or consequential
damages whatsoever (including, but not limited to damages for loss of
business profits, business interruption, loss of business information,
or any other pecuniary loss) arising out of the use of or inability to
use or misuse of the software product or the provision of or failure to
provide support services, even if the author has been advised of the
possibility of such damages.
/***************************************************************************/

#pragma hdrstop

#include "ioGUI.h"
#include "io.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  Label1->Caption="";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  long var1=inport(0x0378);
  Label1->Caption=var1;
  Label1->Refresh();
  ::Sleep(200);
  outport(0x0378,0x00ffffff);
  int var2=inportw(0x0378);
  Label1->Caption=var2;
  Label1->Refresh();
  Form1->Refresh();
  ::Sleep(200);
  outportw(0x0378,0xff00);
  short var3=inportb(0x0378);
  Label1->Caption=var3;
  Label1->Refresh();
  Form1->Refresh();
  ::Sleep(200);
  outportb(0x457a,0xda);
  Message();
}
//---------------------------------------------------------------------------

